'use client';

import { useEffect, useState } from 'react';
import { useRouter, usePathname } from 'next/navigation';
import { clearAuthData, getUserProfile, isAuthenticated } from '@/lib/auth';
import GlobalLoad from '../common/GlobalLoad';
import { message } from 'antd';
import { errorHandle } from '@/api/errorHandle';

interface AuthGuardProps {
  children: React.ReactNode;
}

export default function AuthGuard({ children }: AuthGuardProps) {
  const [isLoading, setIsLoading] = useState(true);
  const [isAuthorized, setIsAuthorized] = useState(false);
  const router = useRouter();
  const pathname = usePathname();

  // 不需要鉴权的页面
  const publicPaths = ['/','/login', '/signup', '/forgot-password', '/Terms', '/Privacy', '/activate'];
  const isPublicPath = publicPaths.includes(pathname);

  useEffect(() => {
    const verifyAuth = async () => {
      // 如果是公共页面，不需要鉴权
      if (isPublicPath) {
        setIsAuthorized(true);
        setIsLoading(false);
        return;
      }

      // 检查是否有token
      if (!isAuthenticated()) {
        router.push('/login');
        return;
      }

      try {
        // 调用鉴权接口验证token
        const user = await getUserProfile();
        if (user) {
          setIsAuthorized(true);
        } else {
          router.push('/login');
        }
      } catch (errorCode:any) {
        // 强制的领导要求，401和502都跳转到登录页 其他的不管
        if(errorCode.message == 401||errorCode.message == 502){
          router.push('/login');
          clearAuthData();
        }
          errorHandle(errorCode.message)
      } finally {
        setIsLoading(false);
      }
    };

    verifyAuth();
  }, [pathname, router, isPublicPath]);

  // 显示加载状态
  if (isLoading) {
    return (
      <div className="flex items-center justify-center min-h-screen">
        <GlobalLoad show={true} progress={0} />
      </div>
    );
  }

  // 如果未授权，返回null（会由router处理跳转）
  if (!isAuthorized) {
    return null;
  }

  // 授权通过，渲染子组件
  return <>{children}</>;
}
